Attribute VB_Name = "modWeb"
'---------------------------------------------------------------------------------------
' Module      : modWeb
' DateTime    : 21/10/2005 11.36
' Author      : Giorgio Brausi (vbcorner@vbcorner.net - http://www.vbcorner.net/eng)
' Project     : SampleProj
' Purpose     : Some functions for the web
' Descritpion :
' Comments    : OpenUrl   Open a url
'               (use default browser; work with any browser!)
'               SendEMail send a email
'               (use default mailer; work with any mailer!)
'---------------------------------------------------------------------------------------
Option Explicit

Private Declare Function ShellExecute _
    Lib "shell32.dll" Alias "ShellExecuteA" _
    (ByVal hWnd As Long, _
    ByVal lpOperation As String, _
    ByVal lpFile As String, _
    ByVal lpParameters As String, _
    ByVal lpDirectory As String, _
    ByVal nShowCmd As Long) As Long

  Const SW_SHOWNORMAL As Long = 1
  Const sCR = "%0d%0a"   ' Da usare per inserire un ritorno a capo

'---------------------------------------------------------------------------------------
' Procedure   : OpenUrl
' DateTime    : 24/02/2005 11.01
' Author      : Giorgio Brausi (vbcorner@vbcorner.net - http://www.vbcorner.net)
' Purpose     : Apre la pagina web indicata in strURL
' Descritpion : Usa il browser predefinito
' Comments    : Funziona con qualsiasi browser
'---------------------------------------------------------------------------------------
Public Sub OpenUrl(ByVal strURL As String)

  Call ShellExecute(0, "Open", strURL, 0&, 0&, SW_SHOWNORMAL)

End Sub
'---------------------------------------------------------------------------------------
' Procedure   : SendEMail
' DateTime    : 24/02/2005 11.02
' Author      : Giorgio Brausi (vbcorner@vbcorner.net - http://www.vbcorner.net)
' Purpose     : Send a email
' Descritpion :
' Comments    : Please note that the this routine DON'T work with any mailer!
'---------------------------------------------------------------------------------------
Public Sub SendEMail(ByVal sEmailAddress As String, Optional ByVal sSubject As String = "", Optional ByVal sBody As String = "")
Rem HotTo use:
Rem Call ShellExecute(0, "Open", "mailto:email_address?Subject=your_subject?Body=body_message", "", "", 1)

  Rem sBody = sCR & "Dear friend" & sCR & sCR  & "I will..."
  Rem --------------------------------------------------
  
  Call ShellExecute(0, "Open", "mailto:" & sEmailAddress & "?Subject=" & sSubject & "?Body=" & sBody, "", "", SW_SHOWNORMAL)

End Sub
